/**
 * This file is part of BoardSim.
 * Copyright (c) 2017, University of Toulouse
 *
 * BoardSim is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * BoarSim is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with BoardSim.  If not, see <http://www.gnu.org/licenses/>
 */

#include <QDate>
#include <QTime>

#include <Board.hpp>
#include <IComponent.hpp>
#include <IRegister.hpp>

#include "Generator.hpp"

using namespace bsim;

extern QString APP;
extern QString VERSION;


class CGenerator: public Generator {
	
	QString macroID(QString id) {
		QString buf;
		bool first = true;
		for(int i = 0; i < id.size(); i++) {
			QChar c = id[i];
			if(c.isLetter())
				c = c.toUpper();
			else if(c.isNumber()) {
				if(first)
					c = '_';
			}
			else if(c != '_')
				c = '_';
			buf = buf + c;
			first = false;
		}
		return buf;
	}
	
	QString macroID(QString pref, QString suff) {
		return macroID(pref + "_" + suff);
	}

	void genConst(QTextStream& out, const Constant& cst, QString pref = "") {
		switch(cst.type()) {
		case Constant::NONE:
			break;
		case Constant::UINT:
			out << QString("#define %1%2%3 0x%4\n")
				.arg(macroID(pref))
				.arg(pref == "" ? "" : "_")
				.arg(macroID(cst.name()))
				.arg(cst.value(), 0, 16);
			break;
		case Constant::ADDR:
			out << QString("#define %1%2%3 %4\n")
				.arg(macroID(pref))
				.arg(pref == "" ? "" : "_")
				.arg(macroID(cst.name()))
				.arg(cst.value(), 8, 16);
			break;
		case Constant::MASK:
			out << QString("#define %1%2%3 (1 << %4)\n")
				.arg(macroID(pref))
				.arg(pref == "" ? "" : "_")
				.arg(macroID(cst.name()))
				.arg(cst.shift());
			break;
		case Constant::FIELD:
			out << QString("#define %1%2%3 (0x%4 << %5)\n")
				.arg(macroID(pref))
				.arg(pref == "" ? "" : "_")
				.arg(macroID(cst.name()))
				.arg(cst.value(), 0, 16)
				.arg(cst.shift());
			break;
		}
	}
	
public:
	virtual QString extension(void) {
		return ".h";
	}
	
	virtual void genRegister(QTextStream& out, IComponent& comp, IHardRegister& reg) {
		if(reg.count() == 1)
			out << QString("#define %1 (*(volatile uint32_t *)(%2_BASE + 0x%3))\n")
				.arg(macroID(reg.qualifiedName(&comp)))
				.arg(macroID(comp.name()))
				.arg(reg.address() - comp.address(), 0 , 16);
		else if(reg.size() / 8 == reg.stride())
			out << QString("#define %1 ((volatile uint32_t *)(%2_BASE + 0x%3))\n")
				.arg(macroID(reg.qualifiedName(&comp)))
				.arg(macroID(comp.name()))
				.arg(reg.address() - comp.address(), 0 , 16);
		else
			out << QString("#define %1(i) (*(volatile uint32_t *)(%2_BASE + 0x%3 + 0x%4 * (i)))\n")
				.arg(macroID(reg.qualifiedName(&comp)))
				.arg(macroID(comp.name()))
				.arg(reg.address() - comp.address(), 0 , 16)
				.arg(reg.stride(), 0, 16);
	}
	
	virtual void generate(QTextStream& out, Board& board) {
		
		// generate header
		out << "/*\n"
			<< " * Definitions for board " << board.name() << endl
			<< " * Generated by " << APP << " v" << VERSION << " (" << QDate::currentDate().toString() << " " << QTime::currentTime().toString() << ")\n"
			<< " */\n\n"
			<< "#ifndef " << macroID(board.name().toUpper()) << "_H\n"
			<< "#define "  << macroID(board.name().toUpper()) << "_H\n"
			// << "#include <stdint.h>\n\n";	// should be activated some day
			<< "#include <sys/types.h>\n"
			<< "typedef __uint32_t uint32_t;\n"
			<< "\n"
			<< "#define MCK " << board.mck() << "\n"
			<< endl;
		
		// generate static definitions
		QSet<QString> types;
		QSet<QString> bits;
		const QMap<QString, IComponent *>& comps = board.getComponents();
		for(QMap<QString, IComponent*>::const_iterator comp = comps.begin(); comp != comps.end(); ++comp)
			if(!types.contains((*comp)->type())) {
				types.insert((*comp)->type());
				QVector<Constant> csts;
				(*comp)->getStaticConstants(csts);
				bool nl = false;
				
				// generate constants
				if(csts.size()) {
					out << "/* definitions for " << (*comp)->type() << "*/\n";
					for(int i = 0; i < csts.size(); i++) {
						genConst(out, csts[i], csts[i].isPrefixed() ? macroID((*comp)->type()) : ""); 
						nl = true;
					}
				}
				
				// generate the header
				(*comp)->genHeader(IComponent::C, out);
				
				// generate ther register constants
				const QVector<IRegister *>& regs = (*comp)->getRegisters();
				for(int i = 0; i < regs.size(); i++) {
					const QVector<IRegister::Field *>& fields = regs[i]->fields();
					for(int j = 0; j < fields.size(); j++)
						if(fields[j]->name() != "" && !bits.contains(fields[j]->name())) {
							
							// single bit
							if(fields[j]->size() == 1)
								out << QString("#define %1_%2 (1 << %3)\n").arg((*comp)->typePrefix()).arg(fields[j]->name()).arg(fields[j]->bit());
							
							// field with enumeration
							else if(fields[j]->hasValues()) {
								const QVector<IRegister::EnumValue>& vals = fields[j]->values();
								for(int k = 0; k < vals.size(); k++)
									out << QString("#define %1_%2_%3 ((0x%4) << %5)\n")
										.arg((*comp)->typePrefix())
										.arg(fields[j]->name())
										.arg(vals[k].name())
										.arg(vals[k].value(), 0, 16)
										.arg(fields[j]->bit());
							}
							
							// field with array
							else if(fields[j]->type() == IRegister::ARRAY)
								out << QString("#define %1_%2(x) (1 << (%3 + (x)))\n").arg((*comp)->typePrefix()).arg(fields[j]->name()).arg(fields[j]->bit());
							
							// field with value
							else
								out << QString("#define %1_%2(x) ((x) << %3)\n").arg((*comp)->typePrefix()).arg(fields[j]->name()).arg(fields[j]->bit());

							bits.insert(fields[j]->name());
							nl = true;
						}
				}
				
				if(nl)
					out << endl;
			}
		
		// generate dynamic definitions
		for(QMap<QString, IComponent*>::const_iterator comp = comps.begin(); comp != comps.end(); ++comp) {
			
			// collect data
			QVector<Constant> csts;
			(*comp)->getDynamicConstants(csts);
			QVector<IHardRegister *> regs;
			const QVector<IRegister *>& all_regs = (*comp)->getRegisters();
			for(int i = 0; i < all_regs.size(); i++) {
				IHardRegister *reg = all_regs[i]->toHard();
				if(reg)
					regs.append(reg);
			}
			
			// if there is something to do
			if(csts.size() || regs.size()) {
				
				// output header
				out << "/* definitions for " << (*comp)->name() << "*/\n";
				genConst(out, Constant("BASE", (*comp)->address()), (*comp)->name());
				
				// generate the dynamic definitions
				if(csts.size())
					for(int i = 0; i < csts.size(); i++)
						genConst(out, csts[i], csts[i].isPrefixed() ? macroID(csts[i].name()) : "");
				
				// generate the registers
				if(regs.size()) {
					for(int i = 0; i < regs.size(); i++)
						genRegister(out, **comp, *regs[i]);
					out << endl;
				}
			}
		}
		
		// generate footer
		out	<< "#endif /* "  << macroID(board.name().toUpper()) << "_H */\n";
	}

};

/**
 * Generator singleton.
 */
static CGenerator _c_generator;
Generator& c_generator = _c_generator;
